unit AXScriptDemo_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ AXScriptDemo Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_AXScriptDemo: TGUID = '{286ACC40-D51D-11D0-900D-444553540000}';

const

{ Component class GUIDs }
  Class_CoolObject: TGUID = '{D6F31229-E438-11D0-900D-444553540000}';

type

{ Forward declarations: Interfaces }
  ICoolObject = interface;
  ICoolObjectDisp = dispinterface;
  ICoolObjectEvents = dispinterface;

{ Forward declarations: CoClasses }
  CoolObject = ICoolObject;

{ Dispatch interface for TTooCool Object }

  ICoolObject = interface(IDispatch)
    ['{D6F31228-E438-11D0-900D-444553540000}']
    procedure ShowMessage(const S: WideString); safecall;
    function Get_CurrentMessage: WideString; safecall;
    procedure Set_CurrentMessage(const Value: WideString); safecall;
    procedure ShowMessageNoEvent(const S: WideString); safecall;
    property CurrentMessage: WideString read Get_CurrentMessage write Set_CurrentMessage;
  end;

{ DispInterface declaration for Dual Interface ICoolObject }

  ICoolObjectDisp = dispinterface
    ['{D6F31228-E438-11D0-900D-444553540000}']
    procedure ShowMessage(const S: WideString); dispid 1;
    property CurrentMessage: WideString dispid 2;
    procedure ShowMessageNoEvent(const S: WideString); dispid 3;
  end;

  ICoolObjectEvents = dispinterface
    ['{D6F3122B-E438-11D0-900D-444553540000}']
    procedure OnShowMessage(const S: WideString); dispid 1;
  end;

{ CoolObject CoClass }

  CoCoolObject = class
    class function Create: ICoolObject;
    class function CreateRemote(const MachineName: string): ICoolObject;
  end;



implementation

uses ComObj;

class function CoCoolObject.Create: ICoolObject;
begin
  Result := CreateComObject(Class_CoolObject) as ICoolObject;
end;

class function CoCoolObject.CreateRemote(const MachineName: string): ICoolObject;
begin
  Result := CreateRemoteComObject(MachineName, Class_CoolObject) as ICoolObject;
end;


end.
